Summary: The most widely used Web server on the Internet.
Summary(cs): Nejrozenj internetov WWW server.
Name: apache
Version: 1.3.9
Release: 5cs.suexecfix
Group: System Environment/Daemons
%define mczversion 1.3.4_3.1.0b4
%define mczpversion 1.3.6_3.1.0b4
%define mczdir mcz_%{mczversion}
%define apversion 1.3.9
%define modversion 2.4.2

Source: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
Source1: apache-index.html
Source2: poweredby.gif
Source3: httpd.init
Source4: apache.logrotate
Source5: apache-access.conf
Source6: apache-httpd.conf
Source7: apache-srm.conf
Source8: mod_bandwidth.c
Source9: http://www.intersoft.cz/mod_czech/download/mod_czech3/Version_3_1_0b/Apache_1_3_4_Version/mcz_%{mczversion}.tgz
Source10: http://www.modssl.org/source/mod_ssl-%{modversion}-%{apversion}.tar.gz

Patch0: apache_1.3.6-redhat.patch
Patch1: apache_1.3.9-apxs-ivop.patch
Patch2: mcz-patch_%{mczpversion}
Patch3: mcz-mvfix.patch
Patch4: mcz-ivop-http_protocol.patch
Patch5: mcz-ivop-filters.patch
Patch6: ivop-httpd_conf.patch

Copyright: Freely distributable and usable
BuildRoot: /var/tmp/apache-root
Requires: /etc/mime.types
Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, mailcap, grep, textutils
Provides: webserver
Packager: Ivo Panacek <ivop@regionet.cz>

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

Install the apache package if you need a Web server.

Package includes these extensions:
 - mod_czech (module for automatic conversion between different Czech
   character encodings) from http://www.intersoft.cz/mod_czech/
 - EAPI from mod_ssl to enable build it as DSO module separately

Warning: mod_czech is not ready (in current version) to be compiled
into Apache and at the same time not used (missing directive AddModule).
Until repaired, do NOT comment out that directive if httpd.conf.
The module functionality can be always disabled using directive
"CzechModule off".

%description -l cs
Apache je vkonn, efektivn, voln iiteln WWW server s mnoha
vlastnostmi. Je nejrozenj WWW server na internetu.

Tento balk obsahuje tato rozen:
 - mod_czech (modul pro automatick pekdovvn dokument mezi
   rznmi kdovmi sadami) z http://www.intersoft.cz/mod_czech/
 - EAPI z balku mod_ssl, aby ho bylo mon pekldat zvlt
   jako DSO modul

Varovn: mod_czech nen v tto verzi pipraven na situaci, kdy je
sice zakompilovn do Apache, ale nen povolen (direktivou AddModule).
Ne to bude opraveno, tuto direktivu tam nechte. Vlastn modul
mete vdycky vypnout direktivou "CzechModule off".

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache Web server.
Summary(cs): Vvojov nstroje pro Apache.
Obsoletes: secureweb-devel

%description devel
The apache-devel package contains the source code for the Apache
Web server and the APXS binary you'll need to build Dynamic
Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server, and you want to be 
able to compile or develop additional modules for Apache, you'll 
need to install this package.

%description -l cs devel
Balk devel obsahuje hlavikov soubory a program apxs, kter jsou
nutn pro vvoj a kompilace DSO (dynamicky sdlench objekt) pro
server Apache.

%prep
%setup -q -n apache_%{version}
%patch0 -p1 -b .redhat
%patch1 -p1 -b .apxs-ivop

# mod_czech setup:

# 1. base mcz files
%setup -T -D -q -b 9 -n apache_%{version}

# 2. patch original apache
cd src
%patch2 -p1 -b .mod_czech
%patch3 -p2 -b .mod_czech-mvfix
%patch4 -p0 -b .mod_czech-ivop

# mod_ssl setup:

cd ../..
%setup -T -D -b 10 -n apache_%{version}

%build

cd ../mod_ssl-%{modversion}-%{apversion}
OPTIM="$RPM_OPT_FLAGS" \
	./configure --verbose --prefix=/usr \
	--with-apache=../apache_%{apversion} \
	--with-ssl=SYSTEM \
	--with-eapi-only


cd ../apache_%{apversion}
OPTIM="$RPM_OPT_FLAGS" \
	./configure --prefix=/usr \
	--with-layout=RedHat \
	--add-module=%{SOURCE8} \
	--activate-module=src/modules/czech/libczech.a	\
	--enable-module=all \
	--enable-shared=max \
	--enable-rule=EAPI \
	--disable-shared=czech	\
	--disable-shared=alias	\
	--disable-rule=WANTHSREGEX \
	--disable-module=auth_dbm \
	--with-perl=/usr/bin/perl \
	--enable-suexec \
	--suexec-docroot=/home/httpd/html \
	--suexec-userdir=html \
	--suexec-caller=nobody

make

# mod_czech
( cd src ; patch -p0 < %{PATCH5} )

	
%install
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT
strip $RPM_BUILD_ROOT/usr/sbin/httpd

# remove apachectl; we have our own SYSV init stuff
rm $RPM_BUILD_ROOT/usr/sbin/apachectl
rm $RPM_BUILD_ROOT/usr/man/man8/apachectl.8

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

for I in 0 1 2 6; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/K15httpd
done
for I in 3 5; do
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc$I.d
	ln -s ../init.d/httpd $RPM_BUILD_ROOT/etc/rc.d/rc$I.d/S85httpd
done

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache

ln -s ../../var/log/httpd $RPM_BUILD_ROOT/etc/httpd/logs
ln -s ../../usr/lib/apache $RPM_BUILD_ROOT/etc/httpd/modules

install -m644 $RPM_SOURCE_DIR/apache-index.html \
        $RPM_BUILD_ROOT/home/httpd/html/index.html
install -m644 $RPM_SOURCE_DIR/poweredby.gif \
	$RPM_BUILD_ROOT/home/httpd/html

# replace Apache's default config files with our own versions
install -m644 $RPM_SOURCE_DIR/apache-access.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/access.conf

install -m644 $RPM_SOURCE_DIR/apache-httpd.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/httpd.conf

install -m644 $RPM_SOURCE_DIR/apache-srm.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/srm.conf

# install apache source code for devel package
#mkdir -p $RPM_BUILD_ROOT/usr/src
#tar xzf $RPM_SOURCE_DIR/apache_%{version}.tar.gz -C $RPM_BUILD_ROOT/usr/src
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|/usr/bin/perl|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"

# mod_czech
cat $RPM_BUILD_DIR/mcz_%{mczversion}/mcz_config \
    >> $RPM_BUILD_ROOT/etc/httpd/conf/czech.conf

( cd $RPM_BUILD_ROOT/etc/httpd/conf ; patch -p0 < %{PATCH6} )


( cd $RPM_BUILD_DIR/mcz_%{mczversion};
  mkdir mod_czech ;
  cp README CHANGES TODO INSTALL mod_czech )

install -d $RPM_BUILD_ROOT/home/httpd/html/manual/mod/mod_czech
install -m644 $RPM_BUILD_DIR/mcz_%{mczversion}/doc/* \
              $RPM_BUILD_ROOT/home/httpd/html/manual/mod/mod_czech

install -d $RPM_BUILD_ROOT/home/httpd/icons/mod_czech
install -m644 $RPM_BUILD_DIR/mcz_%{mczversion}/pictures/* \
              $RPM_BUILD_ROOT/home/httpd/icons/mod_czech

install -m644 \
     $RPM_BUILD_DIR/apache_%{version}/src/modules/czech/charconv/charconv.h \
     $RPM_BUILD_ROOT/usr/include/apache

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd
[ -f /etc/mime.types ] || exit 0
# safely add .htm to mime types if it is not already there
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /etc/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /etc/mime.types
  types=$(grep "^text/html" /etc/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /etc/mime.types && /bin/rm -f $TEMPTYPES

%preun
if [ $1 = 0 ]; then
   /etc/rc.d/init.d/httpd stop > /dev/null 2>&1
   /sbin/chkconfig --del httpd
   /bin/rm -fr /var/log/httpd/*
fi
  
%files
%defattr(-,root,root)
%dir /etc/httpd/conf
%config /etc/httpd/conf/access.conf
%config /etc/httpd/conf/srm.conf
%config /etc/httpd/conf/httpd.conf
%config /etc/httpd/conf/czech.conf
%config /etc/httpd/conf/magic

/etc/httpd/logs
/etc/httpd/modules
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd
%config(missingok) /etc/rc.d/rc3.d/S85httpd
%config(missingok) /etc/rc.d/rc5.d/S85httpd
%config(missingok) /etc/rc.d/rc0.d/K15httpd
%config(missingok) /etc/rc.d/rc1.d/K15httpd
%config(missingok) /etc/rc.d/rc2.d/K15httpd
%config(missingok) /etc/rc.d/rc6.d/K15httpd

%dir /home/httpd
%dir /home/httpd/cgi-bin
%dir /home/httpd/html
%config(noreplace) /home/httpd/html/index.html
/home/httpd/html/poweredby.gif
/home/httpd/html/manual
/home/httpd/icons

/usr/lib/apache
/usr/man/*/*
/usr/sbin/ab
/usr/sbin/httpd
/usr/sbin/logresolve
/usr/sbin/rotatelogs
%attr(4711,root,root) /usr/sbin/suexec
/usr/bin/*

%attr(-,nobody,nobody) %dir /var/cache/httpd
%dir /var/log/httpd

%doc $RPM_BUILD_DIR/mcz_%{mczversion}/mod_czech
%doc src/README* src/CHANGES src/BUILD.NOTES src/INSTALL src/PORTING

%files devel
%defattr(-,root,root)
/usr/include/apache
/usr/sbin/apxs

%changelog
* Fri Oct 08 1999 Ivo Panacek <ivop@regionet.cz>
- fixed wrong apxs LIBEXECDIR

* Mon Oct 04 1999 Ivo Panacek <ivop@regionet.cz>
- sync with apache-1.3.9-4 from RedHat 6.1:
    Tue Sep 21 1999 Bill Nottingham <notting@redhat.com>
    - move DSO in httpd.conf to after ServerRoot
    Mon Sep 20 1999 Preston Brown <pbrown@redhat.com>
    - it is httpd stop, not httpsd stop (# 5254)
    - suexec added (# 5257)
    Thu Sep 09 1999 Preston Brown <pbrown@redhat.com>
    - remove apachectl man page (# 4459)
  actually not all the changes in new source files were accepted,
  especially apache.logrotate and httpd.init are hopefully wrong
- mod_czech now enabled by default

* Mon Sep 13 1999 Ivo Panacek <ivop@regionet.cz>
- EAPI from mod_ssl included so mod_ssl can be compiled
  as DSO using apxs

* Mon Sep 13 1999 Ivo Panacek <ivop@regionet.cz>
- added mod_czech for czech charsets encoding
  with modifications by Michal Choura <xchoura@fel.cvut.cz>

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 1.3.9
- fix bug # 3680 (suexec docroot was wrong)
- fix bug # 2378 (logrotate with -USR1 not -HUP)
- fix bug # 3548 (logrotate complains if apache not running)
- httpd.conf is now in the unified apache format as distributed

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging

* Sat May 21 1999 Bill Nottingham <notting@redhat.com>
- fix broken link in index.html

* Wed Apr 07 1999 Bill Nottingham <notting@redhat.com>
- allow indexes in /doc

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binaries

* Mon Apr 05 1999 Preston Brown <pbrown@redhat.com>
- prerequire /bin/rm, added /doc path pointing to /usr/doc for localhost

* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- updated log rotating scripts to not complain if logs aren't present.

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- fixed up path to perl

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- updated init script to conform to new standards
- upgraded to 1.3.6, fixed apxs patch

* Mon Mar 22 1999 Preston Brown <pbrown@redhat.com>
- clean up logfiles on deinstallation

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- added mod_bandwidth
- updated to 1.3.4
- prereq mailcap

* Fri Dec 18 1998 Cristian Gafton <gafton@redhat.com>
- added patch to disable building support for ndbm
- build against glibc 2.1

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.3.3 to catch up with bug fixes
- added the /usr/bin/* binaries to the spec file list

* Fri Sep 25 1998 Cristian Gafton <gafton@redhat.com>
- change ownership of cache dir to nobody
- added "Red Hat" to the server string
- updated to version 1.3.2
- fixed all references to httpsd in config files

* Fri Sep 04 1998 Cristian Gafton <gafton@redhat.com>
- small fixes to the spec file
- patch to handle correctly the -d <newroot> option
- leave out the .usr.src.apache_%{version} for now

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- patched apxs not to bomb out if it can't find httpd

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- upgraded to apache 1.3.1.
- Heavy rewrite.
- changed providing a_web_server to just webserver.  Humor is not an option.

* Mon Aug 10 1998 Erik Troan <ewt@redhat.com>
- updated to build as non-root user
- added patch to defeat header dos attack

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- fixed the default config files to be more paranoid about security

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- fixed init script
- added index.htm to the list of acceptable indexes

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.2.6
- added post script to install htm extension for text/html into
  /etc/mime.types

* Wed Apr 22 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhanced sysv init script

* Tue Jan 06 1998 Erik Troan <ewt@redhat.com>
- updated to 1.2.5, which includes many security fixes

* Wed Dec 31 1997 Otto Hammersmith <otto@redhat.com>
- fixed overkill on http.init stop

* Wed Dec 31 1997 Erik Troan <ewt@redhat.com>
- added patch for backslash DOS attach

* Thu Nov 06 1997 Donnie Barnes <djb@redhat.com>
- added htdigest binary to file list

* Mon Nov 03 1997 Donnie Barnes <djb@redhat.com>
- made the default index.html be config(noreplace) so we no longer
  blow away other folks' index.html

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added chkconfig support
- added restart|status options to initscript
- renamed httpd.init to httpd

* Tue Oct 07 1997 Elliot Lee <sopwith@redhat.com>
- Redid spec file, patches, etc. from scratch.
